# -*- Mode:Perl; -*-
#
# Mkdir - Utility routine for creating directories
#
# Synopsis:
#    &Mkdir( pathname )
# 
# Errors:
#    Prints to stderr if the named directory cannot be created; returns 
#    a value 0.
#
# Returns:
#    Return value is one on success and zero on failure

#
# Check for and create if necessary the named directory
sub Mkdir {
    my $dirname = $_[0];
    my $sep = "";

    if (! -d $dirname) {
	print "Making directory $dirname\n" if $gDebug;
	$root = "";
	foreach my $part (split(/\//, $dirname)) {
	    if ($part eq "") { $sep = "/"; next; }
	    my $path = $root . $sep . $part;
	    if (! -d $path) {
		print "executing mkdir $path\n" if $gDebug;
		# Early versions of perl require the mask value (e.g.,
		# our LinuxAlpha system)
		my $rc = mkdir $path,0777;
		if ($rc == 0) {
		    print STDERR "Could not mkdir $path\n";
		    return 0;
		}
	    }
	    $root = $path;
	    $sep = "/";
	}
    }
    return 1;
}

1;
