#
# This module handles the various clean targets
#
# Variables Exported
#  gQuiteLine - set to empty to echo all clean lines
$gQuietLine = "@";
#
# Imports:
#    Any module may define a function <Module>OutputClean.  This is 
#    invoked with the arguments ($FD, targetname), e.g., ($FD, "clean")
$KnownActions[$#KnownActions+1] = "CLEAN";

sub OutputCLEAN {
    my $FD = $_[0];

    print $FD "clean:";
    print $FD &SMTargetDependencies( "clean" );
    print $FD "\n";
    #
    # Activate any Clean actions from other modules
    foreach my $action (@KnownActions) {
	my $function = "${action}OutputClean";
	if (defined(&$function)) {
	    &$function( $FD, "clean" );
	}
    }
    &SUBDIRSRecursiveOp( OFD, "clean" );
    if (defined($MakeTargets{"clean-postamble"})) {
	print $FD "\t\$(MAKE) clean-postamble\n";
    }
    print $FD "\n";
}

# Maintainer targets are in maintclean.pl
1;
