#
# -*- Mode:Perl; -*-
#
$missingCopyright = 0;
@FilesWithNoCopyright = ();

sub ClearCopyright {
    $sawCopyright = 0;
}

sub CheckLineCopyright {
    my ($FD, $curline, $filename) =@_;

    if ($curline =~ /See\s+COPYRIGHT/) {
	$sawCopyright = 1;
    }
    if ($curline =~ /C[Oo][Pp][Yy][Rr][Ii][Gg][Hh][Tt]\s+\(C\)/) {
	# This is for files with external copyrights, such as the
	# Etnus/Dolphin files for the Totalview interface
	$sawCopyright = 1;
    }
    
    return $curline;
}

sub ReportOnCopyright {
    my $filename = $_[0];
    if (! $sawCopyright  && ! $gAutogeneratedFile) {
	&PrintCurrentDirectory;
	print "Copyright statement missing from $filename\n";
	$missingCopyright ++;
	$FilesWithNoCopyright[$#FilesWithNoCopyright+1] = $filename;
# 	if ($removeFileMissingCopyright) {
# 	    print "Removing $filename\n";
# 	    unlink $filename;
# 	}
    }
}

sub FinalReportOnCopyright {
    if ($missingCopyright) {
	print STDOUT "\
The following files are missing the copyright statement:\n";
	foreach $file (@FilesWithNoCopyright) {
	    print STDOUT "$file\n";
	}
	if ($removeFileMissingCopyright == 1) {
	    print STDOUT "Files have been removed and an error status returned\n";
	}
    }
}

sub DescribeCopyright {
    print STDOUT 
	"\tcopyright - Check for copyright statements in source code\n";
}

# Add to known actions
$KnownActionsInComments[$#KnownActionsInComments+1] = "Copyright";

1;
