#
# -*- Mode:Perl; -*-
#

%FilesWithTabs = ();

sub CheckLineNoTabs {
    my ($FD, $curline, $filename) =@_;

    if ($gLanguage eq "Fortran") {
	# Check for tabs (not allowed in Fortran)
	if ($curline =~ /\t/) {
	    if (defined($FilesWithTabs{$filename})) {
		$FilesWithTabs{$filename}++;
		if ($FilesWithTabs{$filename} == 2) {
		    print "\t(additional lines with tabs; see summary for count)\n";
		}
	    }
	    else {
		$FilesWithTabs{$filename} = 1;
		my $line = $curline;
		$line =~ s/\r?\n$//;
		print "Fortran file $filename contains a tab on the line\n\t$line\n";
	    }
	}
    }
	
    return $curline;
}

sub FinalReportOnNoTabs {
    my @files = sort(keys(%FilesWithTabs));
    if ($#files >= 0) {
	print STDOUT "\nThe following Fortran files contain tabs (invalid for many Fortran compilers)\nfilename (number of tabs in file):\n";
	foreach my $filename (@files) {
	    my $nlines = $FilesWithTabs{$filename};
	    print STDOUT "$filename ($nlines)\n";
	}
	print STDOUT "\n";
    }
}

# Add to known actions
$KnownActionsForFortran[$#KnownActionsForFortran+1] = "NoTabs";

1;
