#
# -*- Mode:Perl; -*-

#
if (!defined($gDebugPreamble)) {
    $gDebugPreamble = 0;
}

#
# Check for proper preamble.  Record during file reading and check at end
$sawMode                = 0;
%preambleLanguages      = ( "C" => 1, "C++" => 1, "Fortran" => 1, "F90" => 1 );
$gSkipDir = 0;
$gSkipDirTreeDepth = -1;

sub ClearPreamble {
    $sawMode            = 0;
    $gAutogeneratedFile = 0;
}
sub ClearDirPreamble {
}
sub ClearDirTreePreamble {
    if ($gDirDepth == $gSkipDirTreeDepth) {
	$gSkipDir = 0;
	$gSkipDirTreeDepth = -1;
    }
}

sub CheckLinePreamble {
    my ($FD, $curline, $filename) =@_;

    if ($gDebugPreamble) {
	print "Checking $filename for mode and language\n";
	print "Line is $curline\n";
    }
    # Do we want to look for Mode:\s*([^;]+); and then look
    # at $1 for the language?
#    if ($curline =~ /-\*-\s*Mode:\s*([^;]+)/) {
#	print "Saw mode: $1\n";
#    }
    if ($curline =~ /-\*-\s*Mode:\s*C;\s*c-basic-offset:4/) {
	$sawMode   = 1;
	$gLanguage = "C";
    }
    elsif ($curline =~ /-\*-\s*Mode:\s*C\+\+;\s*c-basic-offset:4/) {
	$sawMode   = 1;
	$gLanguage = "C++";
    }
    elsif ($curline =~ /-\*-\s*Mode:\s*Fortran/) {
	$sawMode   = 1;
	$gLanguage = "Fortran";
    }
    elsif ($curline =~ /-\*-\s*Mode:\s*F90/) {
	$sawMode   = 1;
	$gLanguage = "Fortran";
    }
    if ($curline =~/DO NOT EDIT THIS FILE/) {
	$gAutogeneratedFile = 1;
    }
    if ($curline =~ /Generated by configure\./) {
	$gAutogeneratedFile = 1;
    }
    if ($curline =~ /\/\*\s*style:\s*c\+\+ header/) {
	# Did not see Emacs mode command but did see style command
	$cxx_header = 1;
	$gLanguage  = "C++";
	$gCxxComments = 1;
    }

    if ($gDebugPreamble) {
	if ($sawMode) {
	    print "Saw mode and language is $gLanguage\n";
	}
    }
    
    return $curline;
}

sub ReportOnPreamble {
    my $filename = $_[0];

    # Is this a derived file?
    if (-s "$filename.in") { return 0; }
    if (! $gSkipDir && ! $sawMode) {
	# Only report on languages for which we expect or require
	# a mode statement
	if (defined($preambleLanguages{$gLanguage})) {
	    &PrintCurrentDirectory;
	    print "$gLanguage style header missing in $filename\n";
	    $gAvoidConstructionsSeen{"styleheader"} .= "$filename;";
	}
    }
}

# This duplicates the output from gAvoidConstructionsSeen
#sub FinalReportOnPreamble {
#    if (defined($gAvoidConstructionsSeen{"styleheader"})) {
#	print "\nThe following files are missing style headers:\n";
#	foreach my $file (split(/;/,$gAvoidConstructionsSeen{"styleheader"})) {
#	    print $file . "\n";
#	}
#    }
#}

# ---------------------------------------------------------------------------
sub PreambleCheckMode {
    my $flag = $_[0];
    
    $gSkipDir = ! $flag;
    if ($gSkipDirTreeDepth >= 0 && $gDirDepth < $gSkipDirTreeDepth) {
	$gSkipDirTreeDepth = $gDirDepth;
    }
}
# Add to known actions
$KnownActionsInComments[$#KnownActionsInComments+1] = "Preamble";

$gAvoidConstructionsReasons{"styleheader"} = "\
The style header ensures that a common indentation size is used in code; it
also helps to distinguish C from C++ header files";

# ToDo: we need a way to change the language on which we report

1;
