#
# Define coverage targets
# ToDo: provide an option to use -MT -MF when using gcc to collect the 
# dependency data on the fly. 
# To accomplish this will mean modifying the compilation flags to include
# the appropriate options
# 
# Notes:
# This only handles the dependencies for C files.
#
# Imports
# SOURCEGetSourceFilesByType - Given an extension, return the files of
# that type
#
# Question: This is really just C program/library dependencies.  
# Should this be divided into subtypes (allowing dependencies for C, Fortran,
# LaTeX, etc.?)
#
sub ActionDEPENDENCIES {
    my ($sub,$term,$value,$filename,$linecount) = @_;

    # FIXME: Check for an override target?
}

sub ClearDEPENDENCIES {
}

# FIXME: We need to register MAKE_DEPEND_C and ensure that it is
# defined.
sub OutputDEPENDENCIES {
    my $FD = $_[0];
    my $allsources = &SOURCEGetSourceFilesByType( "c" ) . " " . 
	&SOURCEGetSourceFilesByType( "h" );

    if ($allsources =~ /\S/) {
	# if nonempty, add the targets to make the items
    
	print $FD "dependencies: .deps/timestamp ";
	print $FD "$allsources";   # long line this
	# Add the Makefile as a dependency
	print $FD " Makefile";
	print $FD "\n";
	foreach $source (split(/\s+/,$allsources)) {
	    my $base = $source;
	    $source =~ s/\.c$//;
	    print $FD "\t\$(MAKE_DEPEND_C) \$(srcdir)/$source > .deps/$base.Po\n";
	    print $FD "\techo \"include .deps/$base.Po\" >> .deps/newalldeps\n";
	}
	print $FD "\tif [ -s .deps/newalldeps ] ; then mv -f .deps/newalldeps .deps/alldeps ; fi\n";
	print $FD "\tdate > .deps/timestamp\n";
	# FIXME: If we are using GNU make, we can use -include to allow
	# make to ignore a missing .deps/alldeps file.
	print $FD "\ninclude .deps/alldeps\n";
    }
    else {
	# Just add the recursive target
	print $FD "dependencies:\n";
	&SUBDIRSRecursiveOp( $FD, "dependencies" );
    }
    print $FD "\n";
}

sub CompileDEPENDENCIES {
    # FIXME: We need to register the MAKE_DEPEND_C makevar name here
    # if there are any sources
}

# Exports 
sub DEPENDENCIESOutputClean {
    my ($FD, $target) = $_;

# ? Do we want to include any dependency information in a distribution?
#    if ($target eq "distclean") {
#	print $FD "\trm -rf .deps\n";
#    }
    if ($target && $target eq "maintainerclean") {
	print $FD "\trm -rf .deps\n";
    }
}

$KnownActions[$#KnownActions] = "DEPENDENCIES";

1;
