#
# This module handles the various clean targets
#
# Imports:
#    Any module may define a function <Module>OutputClean.  This is 
#    invoked with the arguments ($FD, targetname), e.g., ($FD, "distclean")
$KnownActions[$#KnownActions+1] = "MAINTCLEAN";

#
# FIXME: We'd like to avoid removing the Makefile until the
# last moment.  Should we put the recursive op call first?
sub OutputMAINTCLEAN {
    my $FD = $_[0];

    print $FD "distclean:";
    print $FD &SMTargetDependencies( "distclean" );
    print $FD "\n";
    #
    # Activate any Clean actions from other modules
    foreach my $action (@KnownActions) {
	my $function = "${action}OutputClean";
	if (defined(&$function)) {
	    &$function( $FD, "distclean" );
	}
    }
    &SUBDIRSRecursiveOp( OFD, "distclean" );
    if (defined($MakeTargets{"distclean-postamble"})) {
	print $FD "\t\$(MAKE) distclean-postamble\n";
    }
    print $FD "\n";

    print $FD "maintainerclean:";
    print $FD &SMTargetDependencies( "maintainerclean" );
    print $FD "\n";
    #
    # Activate any Clean actions from other modules
    foreach my $action (@KnownActions) {
	my $function = "${action}OutputClean";
	if (defined(&$function)) {
	    &$function( $FD, "maintainerclean" );
	}
    }
    &SUBDIRSRecursiveOp( OFD, "maintainerclean" );
    if (defined($MakeTargets{"maintainerclean-postamble"})) {
	print $FD "\t\$(MAKE) maintainerclean-postamble\n";
    }
    print $FD "\n";
}

# User clean targets are in clean.pl
1;
