#
# This provides a routine to process all selected files in a directory
#
# ProcessDir( dirname, incl-pattern, excl-pattern, routine, state, cdToDir? )
#
# Maintains these global variables
#    gDirDepth
#    gCurDir
#    gPathToRootDir
# Invokes $routine( localfile, fulldir, state )
# 
# INCOMPLETE AND UNTESTED
#
# Note that to meet the needs of tools such as coding check, we may need 
# additional functions to provide for steps to take when changing directories 
# (such as reading configuration files if present and executing routines to
# clear the 
$depth = 0;
sub ProcessDir {
    my ($dir,$inclPattern, $exclPattern,$fileFunc,$fileState,$cdToDir) = @_;
    my $DIR = "DIR$depth"; $depth++;
    my $savedir = $curdir;
    my $dirDepth = $gDirDepth;

    # Strip off trailing /
    $dir =~ s/\/$//;
    $curdir =~ s/\/$//;

    # Move to new directory and update depth
    $curdir = "$curdir/$dir";
    $gDirDepth++;

    print "Processing directory $curdir\n" if ($gVerbose);

    opendir( $DIR, "$curdir" ) || die "Cannot open directory $curdir\n";
    my @filelist;
    while ($file = readdir($DIR) ) {
	print "File $file\n" if ($gVerbose);
	$filelist[$#filelist+1] = $file;
    }
    closedir( $DIR );
    
    # For each file, decide how to process it.  By default, only 
    # .h, .c, .cxx, .cc, .f, and .f90 files are read.
    # We process regular files first, then directories.  This allows us
    # to define per-directory overrides with a .codingcheck file
    foreach $file (@filelist) {
	if ( !($file =~ /\S/) ) { next; }
	print "processing $curdir/$file\n" if $gVerbose;
	# Skip the subdirectories for now (handled in a separate loop below)
	if (-d "$curdir/$file") {
	    next;
	}
	if ( ($inclPattern eq "" || $file =~ /$inclPattern/ ) &&
	     ($exclPattern eq "" || ! ($file =~ /$exclPattern/) ) {
		 &$fileFunc( $file, $curdir, $fileState );
	     }
	}
    }

    # Process the directories
    foreach $file (@filelist) {
	if ( !($file =~ /\S/) ) { next; }
	print "processing $curdir/$file\n" if $gVerbose;
	if (-d "$curdir/$file") {
	    if (! ($file =~ /^\./) && ! ($file =~ /CVS/) ) { 
		&SetCurrentDirectory( "$curdir/$file" );
		&ProcessDir( $file, $inclPattern, $exclPattern, 
			     $fileFunc, $fileState );
	    }
	    next;
	}
    }

    $curdir    = $savedir;
    $gDirDepth = $dirDepth;
}
