# -*- Mode:Perl; -*-
# ----------------------------------------------------------------------------
# Random configure
# This file is intended for use in the checkbuild environment
# 
# Chosen *without* replacement.  If an option is chosen twice, 
# then there will be fewer options
# returns an array of args
# RandArgs ( number of choices, name of array with values, option prefix,
#            negative option prefix )
# The last two args are typically "enable", "disable" or "with","without"
sub RandArgs { 
    my ($n_choice, $array_name, $optname, $negoptname ) = @_;
    my @chosen = ( );
    my @args = ();
    my $array_len = $#$array_name;
    my $idx;

    print "select $n_choice\n" if $debug;
    for (my $i=0; $i<$n_choice; $i++) {
	$idx = int( rand (1 + $array_len) );
	print "Found $idx\n" if $debug;
	if ($chosen[$idx]) { next; }
	$chosen[$idx] = 1;
	@possibleArgs = split( /;/, $$array_name[$idx] );
	print "Trying $$array_name[$idx]\n" if $debug;
	$name = $possibleArgs[0];
	if ($#possibleArgs == 0) {
	    # Only the name is provided.  Choose one of three
	    # choices:
	    #    No option (skip this one)
	    #    just --$optname-$name
	    #    just --$negoptname-$name (if non-null)
	    $idx = int ( rand ( 3 ) );
	    if ($idx == 0) {
		$args[$#args+1] = "--$optname-$name";
	    }
	    elsif ($idx == 1 && $negoptname ne "") {
		$args[$#args+1] = "--$negoptname-$name";
	    }
	    else {
		# skip
		;
	    }
	}
	else {
	    $idx = 1 + int( rand $#possibleArgs );
	    $value = $possibleArgs[$idx];
	    if ($value ne "") {
		$args[$#args+1] =  "--$optname-$name=$value";
	    }
	    else {
		$args[$#args+1] = "--$optname-$name";
	    }
	}
    }
    return @args;
}

# 
# Configure with a randomly chosen set of options, taken from the 
# arrays:
#      @RandomConfigureEnable
#      @RandomConfigureWith
#      @RandomConfigureEnv
#
# Uses the ConfigureMain sub to execute the configure step
sub RandomConfigureMain {

    my @enable_args = &RandArgs( $n_enable, "RandomConfigureEnable", 
				 "enable", "disable" );
    my @with_args   = &RandArgs ( $n_with, "RandomConfigureWith", 
				  "with", "without" );
    
    # To set the environment, use the same code to set things up,
    # then process the env array to set the environment
    my @env_args    = &RandArgs( $n_env, "RandomConfigureEnv", "env" );

    @ConfigureMainArgs = ( @enable_args, @with_args );
    @ConfigureEnvs = @env_args;
    return ConfigureMain( );
}
