#
# Generate the targets for creating a "TAGS" file
#
$KnownActions[$#KnownActions+1] = "TAGS";

#
# Issues: In the VPATH case, sources may be in the original source directory
# and in the VPATH directory for those that are created by another program
# such as configure.  In that case, we need a slightly different rule.
# (either a file - by - file rule so that make will generate the correct
# path, or a way to separate out the files by which directory they're in)
#

# FIXME:
# How do we set the TAGS_SOURCES and TAGS_HEADERS variables?
# (simplemake used SOURCES and HEADERS, but we should be careful about
# requiring *all* sources).
sub OutputTAGS {
    my $FD = $_[0];
    my $hasSources = 0;

    print $FD "tags: TAGS\n";
    print $FD "TAGS: ";
    if ($hasSources) {
	# This target creates a single TAGS file in the root (relative)
	# location.  Simplemake has a local_tags option as well
	print $FD "\$(TAGS_HEADERS) \$(TAGS_SOURCES)\n";
	my $rootpath = &RootDirGetPathToRootdir;
	print $FD "\there=\`cd $rootpath && pwd\` ; cd \$(srcdir) && etags -o \$\$here/TAGS --append \$(TAGS_HEADERS) \$(TAGS_SOURCES)\n";
    }
    else {
	print $FD "\n";
    }
    &SUBDIRSRecursiveOp( "TAGS" );
}
