# -*- Mode:Perl; -*-
sub XMLify {
    my $line = $_[0];
    my $itcount = 0;
    # xml-ify the line by escaping the special characters
    $line =~ s/</\*AMP\*lt;/g;
    $line =~ s/>/\*AMP\*gt;/g;
    $line =~ s/&/\*AMP\*amp;/g;
    $line =~ s/\*AMP\*/&/g;

    # Handle non-printing ascii characters (e.g., ones that emacs would
    # print as \200).  XML may refuse to display non-printing characters
    # BUG IN PERL: The negated POSIX character class does not work!
    # It isn't clear whether ANY of the POSIX character classes work
    # while ($line =~ /^([:print:]*)([:^print:])(.*)/s) {
    # Instead, we use an explicit ASCII range, and include tab characters
    $outline = "";
    while ($line =~ /^([ -~\t]*)([^ -~\t\n])(.*)/s) {
        # Grr.  This doesn't work either.  The character conversion
	# gets lost.  However, this is still better than including
	# a nonprinting character in the output
        $char = $2;
	$hexversion = sprintf( "\\%03x", $char );
	$outline .= $1 . $hexversion;
	$line    = $3;
	if ($itcount++ > 100) { last; }
    }
    # FIXME: Consider using a hash that maps from non-printing characters
    # to printing versions, along the lines of 
    # '\000' => '\\000'
    # where these are octal characters

    return $outline . $line;
}

1;
