/*
 * This is a test of the doctext program, containing most of the 
 * formatting options
 */

/*N
 Fnode

 Notes on Fnodes:
 This is a sample that includes 
.vb
    verbatim 
    processing
.ve
N*/

/*@ Tst_Msg - A test message routine

  Input Parameters:
. a - first arg
. b - second arg
. c - a two-line description
   of the argument

  This example uses
$   The $ symbol for single-line verbatim output
$   up to this line

.p foo.ps
.cb
   Caption for figure (above)
.ce

.N Fnode

.k break, pointers

@*/
void *Tst_Msg( const int a, void (*b)(), MyType *c, long long (*d)(struct foo),... )
{
}

/* Also try int foo(void) and struct tm *foo2( ... ) */

/* These extra commands will apply only to the following routines */
#include <sys/time.h>  /*I <sys/time.h> I*/
#include <sys/types.h> /*I <sys/types.h> I*/

/*@ 
  TstMsg -
      Another test message routine

  The following parameters do not match the routine; they are here only
  as a test of the formatting commands\:
      
  Input Parameters:
+ -arg 1 - argument with a leading dash
. n, m   - two parameters separated by a comma and
  on two lines
. j      - a normal argument
- l_arg: - a last, two
  line description

  Here is a verbatim block\:
.vb
    12345678901234567890
    a     b c  e
.ve

 Notes:
 This test uses 'tt' and `emphasis formating, which
 may even cross lines`.  It also used doubled quotes to insert
 a single quote into the text, as in this ''example''.

  @*/
EXPORT_API struct tm *TstMsg(void)
  
